#!/usr/bin/python
import socket, sys
from string import atoi
import Image, ImageColor, ImageDraw

ForeColor=ImageColor.getrgb("#ffffff")
img=""

sock=socket.socket(socket.AF_UNIX,socket.SOCK_STREAM)

def enable(IPCpath):
	"Starts the connection. Argument IPCPath is the path to the IPC socket."
	sock.connect(IPCpath)

def standby():
	global img, ForeColor
	"The main routine, really. Reads input from the socket and parses it."
	line = sock.recv(1024)
	if line=='':
		sys.exit(1)
	if line.startswith('QUIT'):
		sock.send("Au revoir...\n")
		return("QUIT")
	if line.startswith('RUDR'):
		sock.send("IMDR\n")
		return("")
	else:
		cmds=line.split(";")
		for cmd in cmds:
			parts=cmd.split(" ")
			if parts[0]=="OF":
				img=Image.open(parts[1])
				img.load()
			if parts[0]=="NPI":
				coords=parts[1].split(",")
				wh=(atoi(coords[0]),atoi(coords[1]))
				img=Image.new("RGB", wh, ForeColor)
			if parts[0]=="CL":
				ForeColor=ImageColor.getrgb("#"+parts[1])
			if parts[0]=="FLR":
				img=img.transpose(Image.FLIP_LEFT_RIGHT)
			if parts[0]=="FTB":
				img=img.transpose(Image.FLIP_TOP_BOTTOM)
			if parts[0]=="ROT":
				angle=atoi(parts[1])
				img=img.rotate(angle)
			if parts[0]=="THUMB":
				w=atoi(parts[1])
				h=atoi(parts[2])
				sz=([w,h])
				img2=img.copy()
				img2.thumbnail(sz, Image.ANTIALIAS)
				img2.save(parts[3])
				sock.send("SAVED\n")
			if parts[0]=="FR":
				coords=parts[1].split(",")
				xyzt=(atoi(coords[0]),atoi(coords[1]),atoi(coords[2]),atoi(coords[3]))
				img.paste(ForeColor, xyzt)
			if parts[0]=="LINE":
				coords=parts[1].split(",")
				draw = ImageDraw.Draw(img)
				xyzt=[(atoi(coords[0]),atoi(coords[1])), (atoi(coords[2]),atoi(coords[3]))]
				draw.line(xyzt,fill=ForeColor)
				del draw
			if parts[0]=="SAVE":
				img.save(parts[1])
				sock.send("SAVED\n")
		return("")

s="/tmp/RB2PIL"+sys.argv[1]
enable(s)
print("PIL gateway started as %s...\n"%(s))
while True:
	v = standby()
	if v != "":
		print("Got %s from standby()"%v)
		if v== "QUIT":
			sys.exit(0)
